#
# spec file for package perl-MooseX-Types-LoadableClass
#
# Copyright (c) 2025 SUSE LLC
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


%define cpan_name MooseX-Types-LoadableClass
Name:           perl-MooseX-Types-LoadableClass
Version:        0.16.0
Release:        1.2
# 0.016 -> normalize -> 0.16.0
%define cpan_version 0.016
License:        Artistic-1.0 OR GPL-1.0-or-later
Summary:        ClassName type constraint with coercion to load the class
URL:            https://metacpan.org/release/%{cpan_name}
Source0:        https://cpan.metacpan.org/authors/id/E/ET/ETHER/%{cpan_name}-%{cpan_version}.tar.gz
Source1:        cpanspec.yml
BuildArch:      noarch
BuildRequires:  perl
BuildRequires:  perl-macros
BuildRequires:  perl(Class::Load)
BuildRequires:  perl(Module::Build)
BuildRequires:  perl(Module::Build::Tiny) >= 0.34.0
BuildRequires:  perl(Module::Metadata)
BuildRequires:  perl(Module::Runtime)
BuildRequires:  perl(Moose)
BuildRequires:  perl(Moose::Role)
BuildRequires:  perl(MooseX::Types)
BuildRequires:  perl(MooseX::Types::Moose)
BuildRequires:  perl(Test::Fatal)
BuildRequires:  perl(Test::More) >= 0.88
BuildRequires:  perl(namespace::autoclean)
BuildRequires:  perl(namespace::clean) >= 0.190
Requires:       perl(Module::Runtime)
Requires:       perl(MooseX::Types)
Requires:       perl(MooseX::Types::Moose)
Requires:       perl(namespace::autoclean)
Provides:       perl(MooseX::Types::LoadableClass) = %{version}
%undefine       __perllib_provides
%{perl_requires}

%description
    use Moose::Util::TypeConstraints;

    my $tc = subtype as ClassName;
    coerce $tc, from Str, via { Class::Load::load_class($_); $_ };

I've written those three lines of code quite a lot of times, in quite a lot
of places.

Now I don't have to.

%prep
%autosetup  -n %{cpan_name}-%{cpan_version} -p1

%build
perl Build.PL --installdirs=vendor
./Build build --flags=%{?_smp_mflags}

%check
./Build test

%install
./Build install --destdir=%{buildroot} --create_packlist=0
%perl_gen_filelist

%files -f %{name}.files
%doc Changes CONTRIBUTING README
%license LICENCE

%changelog
* Mon Apr 21 2025 Tina Müller <timueller+perl@suse.de>
- updated to 0.16.0 (0.016)
  see /usr/share/doc/packages/perl-MooseX-Types-LoadableClass/Changes
  0.016     2025-04-20 16:23:38Z
  - remove unneeded call to ->meta->make_immutable, now necessary with
    MooseX::Types 0.51
* Sat Jun 17 2017 coolo@suse.com
- updated to 0.015
  see /usr/share/doc/packages/perl-MooseX-Types-LoadableClass/Changes
  0.015     2017-06-16 23:37:46Z
  - do not create an extra, unused ClassName type (this fixes a problem
    observed with MooseX::Types and Sub::Defer; see RT#119534)
* Sun Aug 23 2015 coolo@suse.com
- updated to 0.014
  see /usr/share/doc/packages/perl-MooseX-Types-LoadableClass/Changes
  0.014     2015-08-16 02:03:26Z
  - update some distribution tooling
* Fri Feb  6 2015 coolo@suse.com
- updated to 0.013
  - switch from Class::Load to Module::Runtime for loading modules
* Tue Nov 26 2013 coolo@suse.com
- updated to 0.012
  - re-release with fixed encoding in metadata, support files
  - only try to load the class if it's a valid module name (ilmari)
  - avoid trying to load the class if already loaded (minor optimization)
  - repository moved to the github moose organization
* Sat Jul 27 2013 coolo@suse.com
- updated to 0.009
  - now performing type checking in the type check itself, not the coercion,
    to fix results when the type check fails (RT#86041, Karen Etheridge)
* Wed Jun  5 2013 coolo@suse.com
- updated to 0.008
  - Do not require Test::Exception. RT#75246
* Fri Feb 17 2012 coolo@suse.com
- updated to 0.007
  - Be more paranoid about the potential for $_ being clobbered.
* Sat Nov 19 2011 coolo@suse.com
- initial package 0.006
  * created by cpanspec 1.78.06
